/*-
 * Copyright (c)2007 Takuya SHIOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef OBS_GCC_CONFIG_H_
#define OBS_GCC_CONFIG_H_

#define OBS_GNUC_REQUIRE_(maj, min)					      \
((__GNUC__ == (maj) && __GNUC_MINOR__ >= (min)) || (__GNUC__ > (maj)))

#if OBS_GNUC_REQUIRE_(3, 0)
# define OBS_GNUC_ALWAYS_INLINE_	__attribute__((always_inline))
#else
# define OBS_GNUC_ALWAYS_INLINE_
#endif

#ifndef OBS_NO_INLINE
# define OBS_DEF_INLINE_FUNC__(ret, name, args)				      \
static __inline ret name args OBS_GNUC_ALWAYS_INLINE_;			      \
ret name args
#else
# define OBS_DEF_INLINE_FUNC__(ret, name, args)				      \
static ret name args
#endif

#define OBS_DEF_INLINE_FUNC_AU__(ret, name, args)			      \
OBS_DEF_INLINE_FUNC__(ret, name, args)

#ifndef OBS_HAS_STRUCT_ELEM_INIT_
# define OBS_HAS_STRUCT_ELEM_INIT_	1
#endif

#ifndef OBS_HAS_ARRAY_ELEM_INIT_
# define OBS_HAS_ARRAY_ELEM_INIT_	1
#endif

#endif
