/*-
 * Copyright (c)2007 Takuya SHIOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/**@file */

#ifndef OBS_TYPES_H_
#define OBS_TYPES_H_

#include <obs/obs_config.h>

/** some kinds of masks. */
typedef unsigned int OBS_flags;
/** result status code. */
typedef int OBS_status;
/** size. */
typedef size_t OBS_size;
/** max value of OBS_size. */
#define OBS_SIZE_MAX	(~(OBS_size)0)
/** boolean. */
typedef int OBS_bool;

/** unsigned integral type having the same size as data pointer. */
typedef OBS_UINTPTR_TYPE_ OBS_uintptr;
/** signed integral type having the same size as data pointer. */
typedef OBS_INTPTR_TYPE_ OBS_intptr;

/** 8bit signed integer type. */
typedef OBS_INT16_TYPE_ OBS_s8;

/** 8bit unsigned integer type. */
typedef OBS_UINT16_TYPE_ OBS_u8;

/** 16bit signed integer type. */
typedef OBS_INT16_TYPE_ OBS_s16;

/** 16bit unsigned integer type. */
typedef OBS_UINT16_TYPE_ OBS_u16;

/** 32bit signed integer type. */
typedef OBS_INT32_TYPE_ OBS_s32;

/** 32bit unsigned integer type. */
typedef OBS_UINT32_TYPE_ OBS_u32;

/** page offset. */
typedef OBS_PAGE_OFFSET_TYPE_	OBS_page_offset;
/** max value of page offset. */
#define OBS_PAGE_OFFSET_MAX	OBS_PAGE_OFFSET_MAX_
/** shift amount of alignment for the page offset variable. */
#define OBS_PAGE_OFFSET_ALIGN	OBS_PAGE_OFFSET_ALIGN_

/** true. */
#define OBS_TRUE	(1)
/** false. */
#define OBS_FALSE	(0)

#endif
