LIB=obs.lib
DBG=-O2 -Zi
CFLAGS=$(DBG) -nologo -I..

SRCDIR=.
OBJDIR=.libs

OBJS= \
	$(OBJDIR)\obs_pa_insp_file.obj \
	$(OBJDIR)\obs_pa_inspector.obj \
	$(OBJDIR)\obs_pa_winva.obj \
	$(OBJDIR)\obs_pa_wrapper.obj \
	$(OBJDIR)\obs_slab.obj \
	$(OBJDIR)\obs_slab_large.obj \
	$(OBJDIR)\obs_slab_small.obj \
	$(OBJDIR)\obs_stack.obj \
	$(OBJDIR)\obs_status.obj

CLEANFILES= $(OBJS) $(OBJDIR)\$(LIB) $(OBJDIR)\*.pdb

all: $(OBJDIR)\$(LIB)
	@echo.

$(OBJDIR)\$(LIB): $(OBJDIR) $(OBJS)
	lib /nologo /OUT:$(OBJDIR)\$(LIB) $(OBJS)

clean:
	-@for %%i in ($(CLEANFILES)) do @echo removing %%i...  1>&2 && del %%i
	@echo.

$(OBJDIR):
	-mkdir $(OBJDIR)

{$(SRCDIR)}.c{$(OBJDIR)}.obj::
	$(CC) $(CFLAGS) -Fd$(OBJDIR)\ -Fo$(OBJDIR)\ -c $<

DEPDIR=
!INCLUDE deps.mk

$(OBJDIR)\obs_pa_insp_file.obj: obs_pa_insp_file.c $(DEPFILES)
$(OBJDIR)\obs_pa_inspector.obj: obs_pa_inspector.c $(DEPFILES)
$(OBJDIR)\obs_pa_winva.obj: obs_pa_winva.c $(DEPFILES)
$(OBJDIR)\obs_pa_wrapper.obj: obs_pa_wrapper.c $(DEPFILES)
$(OBJDIR)\obs_stack.obj: obs_stack.c $(DEPFILES)
$(OBJDIR)\obs_status.obj: obs_status.c $(DEPFILES)
